Machine
Generated on 18 Mar 2026
https://api.paperspace.com/v1
Endpoints
GET List machine events
/machine-events
Authorizations:
BearerAuth
An API key or access token
Fetches a list of machine events.
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descmachineId
optional
Request: /machine-events
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machine-events"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}GET Get a machine event
/machine-events/{id}
Authorizations:
BearerAuth
An API key or access token
Fetches a single machine event by ID.
Path Parameters
id
required
The ID of the machine event to fetch.
Request: /machine-events/{id}
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machine-events/{id}"Responses
200
Successful response
application/json
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}{
"code": "string",
"message": "string"
}GET List machines
/machines
Authorizations:
BearerAuth
An API key or access token
Fetches a list of machines.
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:dtCreatedorder
optional
The order to sort the results by.
Default:descname
optional
region
optional
agentType
optional
machineType
optional
Request: /machines
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}POST Create a machine
/machines
Authorizations:
BearerAuth
An API key or access token
Creates a new machine.
Request Body: application/json
accessorIds
optional
The IDs of users to grant access to the machine.
autoShutdownEnabled
optional
Whether to enable auto shutdown.
autoShutdownForce
optional
Whether to force shutdown the machine.
autoShutdownTimeout
optional
The auto shutdown timeout in hours.
autoSnapshotEnabled
optional
Whether to enable auto snapshots.
autoSnapshotFrequency
optional
The auto snapshot frequency.
autoSnapshotSaveCount
optional
The number of auto snapshots to save.
diskSize
required
The disk size in gigabytes.
emailPassword
optional
Whether to email the password.
enableNvlink
optional
Whether to enable NVLink.
machineType
required
The machine type. This must correspond to a machine type label as indicated in List OS templates or List templates.
name
required
The name of the new machine.
networkId
optional
The network ID.
publicIpType
optional
The public IP type.
region
required
The region to create the machine in.
restorePointEnabled
optional
Whether to use initial snapshot as a restore point.
restorePointFrequency
optional
The restore point frequency.
startOnCreate
optional
Whether to start the machine on creation.
startupScriptId
optional
The startup script ID.
takeInitialSnapshot
optional
Whether to take an initial snapshot.
templateId
required
The template ID. See List OS templates or List templates.
Request: /machines
{
"accessorIds": [
"string"
],
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"diskSize": 0,
"emailPassword": true,
"enableNvlink": true,
"machineType": "string",
"name": "string",
"networkId": "string",
"publicIpType": "static",
"region": "ny2",
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"startOnCreate": true,
"startupScriptId": "string",
"takeInitialSnapshot": true,
"templateId": "string"
}curl -X POST \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"accessorIds": [
"string"
],
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"diskSize": 0,
"emailPassword": true,
"enableNvlink": true,
"machineType": "string",
"name": "string",
"networkId": "string",
"publicIpType": "static",
"region": "ny2",
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"startOnCreate": true,
"startupScriptId": "string",
"takeInitialSnapshot": true,
"templateId": "string"
}' \
"https://api.paperspace.com/v1/machines"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}GET Get a machine
/machines/{id}
Authorizations:
BearerAuth
An API key or access token
Fetches a single machine by ID.
Path Parameters
id
required
The ID of the machine to fetch.
Request: /machines/{id}
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}"Responses
200
Successful response
application/json
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"accelerators": [
{
"count": 0,
"memory": 0,
"name": "string"
}
],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
}{
"code": "string",
"message": "string"
}PUT Update a machine
/machines/{id}
Authorizations:
BearerAuth
An API key or access token
Updates a machine.
Path Parameters
id
required
The ID of the machine to update.
Request Body: application/json
autoShutdownEnabled
optional
Whether to enable auto shutdown.
autoShutdownForce
optional
Whether to force shutdown the machine.
autoShutdownTimeout
optional
The auto shutdown timeout in hours.
autoSnapshotEnabled
optional
Whether to enable auto snapshots.
autoSnapshotFrequency
optional
The auto snapshot frequency.
autoSnapshotSaveCount
optional
The number of auto snapshots to save.
diskSize
optional
The disk size in gigabytes.
machineType
optional
The machine type. This must correspond to a machine type label as indicated in List OS templates or List templates.
name
optional
The name of the machine.
networkId
optional
The network ID.
publicIpType
optional
The public IP type.
restorePointEnabled
optional
Whether to use initial snapshot as a restore point.
restorePointFrequency
optional
The restore point frequency.
restorePointSnapshotId
optional
The restore point snapshot ID.
Request: /machines/{id}
{
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"diskSize": 0,
"machineType": "string",
"name": "string",
"networkId": "string",
"publicIpType": "static",
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string"
}curl -X PUT \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"diskSize": 0,
"machineType": "string",
"name": "string",
"networkId": "string",
"publicIpType": "static",
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string"
}' \
"https://api.paperspace.com/v1/machines/{id}"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
optional
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}DELETE Delete a machine
/machines/{id}
Authorizations:
BearerAuth
An API key or access token
Deletes a single machine by ID.
Path Parameters
id
required
The ID of the machine to delete.
Request: /machines/{id}
curl -X DELETE \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}GET List accessors
/machines/{id}/accessors
Authorizations:
BearerAuth
An API key or access token
Lists the team members that can explicitly access a machine.
Path Parameters
id
required
The ID of the machine.
Query Parameters
after
optional
Fetch the next page of results after this cursor.
limit
1 – 120 optional
The number of items to fetch after this page.
orderBy
optional
Order results by one of these fields.
Default:idorder
optional
The order to sort the results by.
Default:descRequest: /machines/{id}/accessors
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}/accessors"Responses
200
Successful response
application/json
hasMore
required
Whether there are more pages of results available.
items
required
The items on this page.
Show child properties
dtDeleted
optional Nullable
The date the user was removed from the machine as an accessor.
user
required
The user that can access the machine
Show child properties
email
required
The email address of the user
firstName
optional Nullable
The first name of the user
id
required
The ID of the user
lastName
optional Nullable
The last name of the user
publicProfileImageUrl
optional Nullable
The URL of the team's profile image.
nextPage
optional
The cursor required to fetch the next page of results. i.e. ?after=nextPage. This is null when there is no next page.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"hasMore": true,
"items": [
{
"dtDeleted": "2019-08-24T14:15:22Z"
}
],
"nextPage": "string"
}{
"code": "string",
"message": "string"
}POST Add an accessor
/machines/{id}/accessors
Authorizations:
BearerAuth
An API key or access token
Adds an accessor to a machine.
Path Parameters
id
required
The ID of the machine to add an accessor to.
Request Body: application/json
userId
required
The ID of the user to add as an accessor. This can be found on the team members page at https://console.paperspace.com/settings/members.
Request: /machines/{id}/accessors
{
"userId": "string"
}curl -X POST \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
-d '{
"userId": "string"
}' \
"https://api.paperspace.com/v1/machines/{id}/accessors"Responses
200
Successful response
application/json
dtDeleted
optional Nullable
The date the user was removed from the machine as an accessor.
user
required
The user that can access the machine
Show child properties
email
required
The email address of the user
firstName
optional Nullable
The first name of the user
id
required
The ID of the user
lastName
optional Nullable
The last name of the user
publicProfileImageUrl
optional Nullable
The URL of the team's profile image.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"dtDeleted": "2019-08-24T14:15:22Z",
"user": {
"email": "string",
"firstName": "string",
"id": "string",
"lastName": "string",
"publicProfileImageUrl": "string"
}
}{
"code": "string",
"message": "string"
}GET Get an accessor
/machines/{id}/accessors/{userId}
Authorizations:
BearerAuth
An API key or access token
Get an accessor for a machine.
Path Parameters
id
required
The ID of the machine to get an accessor for.
userId
required
The ID of the user to get. This can be found on the team members page at https://console.paperspace.com/settings/members.
Request: /machines/{id}/accessors/{userId}
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}/accessors/{userId}"Responses
200
Successful response
application/json
dtDeleted
optional Nullable
The date the user was removed from the machine as an accessor.
user
required
The user that can access the machine
Show child properties
email
required
The email address of the user
firstName
optional Nullable
The first name of the user
id
required
The ID of the user
lastName
optional Nullable
The last name of the user
publicProfileImageUrl
optional Nullable
The URL of the team's profile image.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"dtDeleted": "2019-08-24T14:15:22Z",
"user": {
"email": "string",
"firstName": "string",
"id": "string",
"lastName": "string",
"publicProfileImageUrl": "string"
}
}{
"code": "string",
"message": "string"
}DELETE Delete an accessor
/machines/{id}/accessors/{userId}
Authorizations:
BearerAuth
An API key or access token
Deletes an accessor from a machine.
Path Parameters
id
required
The ID of the machine to add an accessor to.
userId
required
The ID of the user to add as an accessor. This can be found on the team members page at https://console.paperspace.com/settings/members.
Request: /machines/{id}/accessors/{userId}
curl -X DELETE \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}/accessors/{userId}"Responses
200
Successful response
application/json
dtDeleted
optional Nullable
The date the user was removed from the machine as an accessor.
user
required
The user that can access the machine
Show child properties
email
required
The email address of the user
firstName
optional Nullable
The first name of the user
id
required
The ID of the user
lastName
optional Nullable
The last name of the user
publicProfileImageUrl
optional Nullable
The URL of the team's profile image.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"dtDeleted": "2019-08-24T14:15:22Z",
"user": {
"email": "string",
"firstName": "string",
"id": "string",
"lastName": "string",
"publicProfileImageUrl": "string"
}
}{
"code": "string",
"message": "string"
}GET Get desktop settings
/machines/{id}/desktop
Authorizations:
BearerAuth
An API key or access token
Gets the machine settings that are used to configure desktop streaming.
Path Parameters
id
required
The ID of the machine.
Request: /machines/{id}/desktop
curl -X GET \
-H "Authorization: Bearer $API_TOKEN" \
"https://api.paperspace.com/v1/machines/{id}/desktop"Responses
200
Successful response
application/json
vnc
optional
Settings for Linux desktop machines.
Show child properties
hostname
required
The VNC hostname.
password
required
The VNC password.
port
required
The port VNC is listening on.
windows
optional
Settings for Windows desktop machines.
Show child properties
hostname
required
The Windows hostname.
port
required
The port Windows is listening on.
publicIp
optional
The public IP of the machine.
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"vnc": {
"hostname": "string",
"password": "string",
"port": 0
},
"windows": {
"hostname": "string",
"port": 0,
"publicIp": "string"
}
}{
"code": "string",
"message": "string"
}PATCH Restart a machine
/machines/{id}/restart
Authorizations:
BearerAuth
An API key or access token
Restarts a machine.
Path Parameters
id
required
The ID of the machine to restart.
Request: /machines/{id}/restart
curl -X PATCH \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
"https://api.paperspace.com/v1/machines/{id}/restart"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}PATCH Start a machine
/machines/{id}/start
Authorizations:
BearerAuth
An API key or access token
Starts a machine.
Path Parameters
id
required
The ID of the machine to start.
Request: /machines/{id}/start
curl -X PATCH \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
"https://api.paperspace.com/v1/machines/{id}/start"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}PATCH Stop a machine
/machines/{id}/stop
Authorizations:
BearerAuth
An API key or access token
Stops a machine.
Path Parameters
id
required
The ID of the machine to stop.
Request: /machines/{id}/stop
curl -X PATCH \
-H "Authorization: Bearer $API_TOKEN" \
-H "Content-Type: application/json" \
"https://api.paperspace.com/v1/machines/{id}/stop"Responses
200
Successful response
application/json
data
required
The machine.
Show child properties
accelerators
optional Nullable
The accelerators of the machine.
Show child properties
count
required
The number of accelerators of this type.
memory
required Nullable
The amount of memory the accelerator has, if applicable.
name
required
The name of the accelerator.
agentType
required
The agent type of the machine.
autoShutdownEnabled
required
Whether auto shutdown is enabled.
autoShutdownForce
required Nullable
Whether to force shutdown the machine.
autoShutdownTimeout
required Nullable
The shutdown timeout of the machine in hours.
autoSnapshotEnabled
required
Whether auto snapshots are enabled.
autoSnapshotFrequency
required Nullable
The frequency of auto snapshots.
autoSnapshotSaveCount
required Nullable
The number of auto snapshots to save.
cpus
required
The number of CPUs.
dtCreated
required
The date the machine was created.
dtDeleted
required Nullable
The date the machine was deleted.
dtModified
required
The date the machine was last modified.
id
required
The ID of the machine.
machineType
required
The type of the machine.
name
required
The name of the machine.
networkId
required Nullable
The ID of the network the machine is on.
os
required
The operating system of the machine.
privateIp
required Nullable
The private IP address of the machine.
publicIp
required Nullable
The public IP address of the machine.
publicIpType
required
The public IP type.
ram
required
The amount of RAM in bytes.
region
required
The region of the machine.
reservation
required Nullable
Show child properties
dtFinished
required
dtStarted
required
id
required
isActive
required
name
required
restorePointEnabled
required
Whether a restore point is enabled.
restorePointFrequency
required Nullable
The frequency of restore points.
restorePointSnapshotId
required Nullable
The ID of the snapshot to use as a restore point.
state
required
The state of the machine.
storageRate
required
The storage rate of the machine.
storageTotal
required
The total amount of storage.
storageUsed
required
The amount of storage used.
updatesPending
required
Whether updates are pending.
usageRate
required
The usage rate of the machine.
event
required
The machine event to poll for the async operation.
Show child properties
dtCreated
required
The date the event was created.
dtFinished
required Nullable
The date the event was finished.
dtStarted
required Nullable
The date the event was started.
error
required Nullable
The error message of the event, if any.
id
required
The ID of the event.
machineId
required Nullable
The ID of the machine the event is for.
name
required
The name of the event, e.g. "create".
state
required
The state of the event, e.g. "done".
default
Error response
application/json
code
required
details
optional
message
required
Response
{
"data": {
"accelerators": [],
"agentType": "string",
"autoShutdownEnabled": true,
"autoShutdownForce": true,
"autoShutdownTimeout": 0,
"autoSnapshotEnabled": true,
"autoSnapshotFrequency": "hourly",
"autoSnapshotSaveCount": 0,
"cpus": 0,
"dtCreated": "2019-08-24T14:15:22Z",
"dtDeleted": "2019-08-24T14:15:22Z",
"dtModified": "2019-08-24T14:15:22Z",
"id": "string",
"machineType": "string",
"name": "string",
"networkId": "string",
"os": "string",
"privateIp": "string",
"publicIp": "string",
"publicIpType": "static",
"ram": 0,
"region": "ny2",
"reservation": {
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
"isActive": true,
"name": "string"
},
"restorePointEnabled": true,
"restorePointFrequency": "shutdown",
"restorePointSnapshotId": "string",
"state": "off",
"storageRate": 0,
"storageTotal": 0,
"storageUsed": 0,
"updatesPending": true,
"usageRate": 0
},
"event": {
"dtCreated": "2019-08-24T14:15:22Z",
"dtFinished": "2019-08-24T14:15:22Z",
"dtStarted": "2019-08-24T14:15:22Z",
"error": "string",
"id": "string",
"machineId": "string",
"name": "bill-sessions",
"state": "new"
}
}{
"code": "string",
"message": "string"
}